package OOPerlTest::Personal::Person;

use Moose;
use Moose::Util::TypeConstraints;

use Data::Dumper;

subtype 'DOB',
   as 'Str',
   where { my ($month, $day, $year) = m|(\d\d)/(\d\d)/(\d{4})|;
             $month ||= 0;
             $day ||= 0;
             !($month < 1 || $month > 12 || $day < 1 || $day > 32);
             },
   message { "Invalid dateOfBirth" };

# if only reality were this simple
has 'name' => (isa => 'Str', is => 'rw', required => 1);
has 'dateOfBirth' => (isa => 'DOB', is => 'rw', required => 1);
has 'alias' => (isa => 'Str', is => 'rw');

sub checkattr {
  my $self = shift;
  my $args = shift;

  for my $attr (keys %$args) {
    if ($attr ne "dateOfBirth" && $attr ne "alias" && $attr ne "name") {
      die "invalidAttribute";
    }
  }
}

sub BUILD {
      my $self = shift;
      my $args = shift;

      $self->checkattr($args)
}

1;
