package OOPerlTest::Personal::WorkUnit;

use Moose;
use Moose::Util::TypeConstraints;
  
subtype 'WorkUnitStatus'
      => as 'Str'
      => where { $_ eq "NotStarted" || $_ eq "Started" || $_ eq "Completed" || $_ eq "Rejected" }
      => message { 'Invalid WorkUnitStatus' };

has 'payload' => (is => 'rw');
has 'task' => (isa => 'Str', is => 'rw', required => 1);
has 'project' => (isa => 'Str', is => 'rw', required => 1);

has 'status' => (isa => 'WorkUnitStatus', is => 'rw', required => 1);

sub checkattr {
  my $self = shift;
  my $args = shift;

  for my $attr (keys %$args) {
    if ($attr ne "task" && $attr ne "project" && $attr ne "status" && $attr ne "payload") {
      die "invalidAttribute";
    }
  }
}

sub BUILD {
  my $self = shift;
  my $args = shift;

  $self->checkattr($args)
}
1;
