#!/usr/bin/perl

# The data after the __END__ token consists of one record per line, with fields
# separated by commas (,). Fields consist of pairs, with the first field in each
# pair giving a name, and the second field giving the corresponding value.
#
# Write a program which achieves the following goals:
#
# 1. The "rent range" is defined as the difference between the maximum rent and
#    the minimum rent (i.e. maxrent - minrent).  For each row of data, compute
#    the rent range.
#
# 2. Sort the rent ranges by how many rows share that range, in descending
#    order by the count of rows, and print the top 5 ranges, along with the
#    count.
#
# 3. Sort the rent ranges by the sum of total_matches values for rows with that
#    rent range, in descending order by the sum of total_matches, and print the
#    top 5 ranges, along with the sum.

# Please do not alter anything above this line.



# Put your code here. You will be evaluated on the basis of the correctness of
# your solution, as well as on the readability and maintainability of your code.
# See the perlstyle man page for style guidance. Good luck!



# Please do not alter anything below this line.

__END__
person_id,97506973,total_matches,3,page,0,minrent,600,maxrent,800,bed,2,bath,2,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,201,num_condos,3,submarket_nb,153,exact_matches,3,location_parse_source,other
person_id,60517347,total_matches,263,page,0,minrent,100,maxrent,800,bed,2,bath,1,pet,1|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,1,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,259,num_condos,4,submarket_nb,101,exact_matches,263,location_parse_source,rent
person_id,97740388,total_matches,25,page,1,minrent,100,maxrent,1000,bed,2,bath,1,pet,1|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,25,num_condos,0,submarket_nb,964,exact_matches,25,location_parse_source,other
person_id,97742020,total_matches,225,page,0,minrent,100,maxrent,1200,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,217,num_condos,8,submarket_nb,739,exact_matches,225,location_parse_source,rent
person_id,59634412,total_matches,225,page,0,minrent,1000,maxrent,1400,bed,2,bath,2,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,209,num_condos,16,submarket_nb,242,exact_matches,225,location_parse_source,other
person_id,97745371,total_matches,195,page,4,minrent,100,maxrent,99999999,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,184,num_condos,11,submarket_nb,927,exact_matches,195,location_parse_source,other
person_id,97745420,total_matches,106,page,0,minrent,100,maxrent,1200,bed,2,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,105,num_condos,1,submarket_nb,1644,exact_matches,106,location_parse_source,rent
person_id,58323392,total_matches,219,page,0,minrent,100,maxrent,1000,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,218,num_condos,1,submarket_nb,31377,exact_matches,219,location_parse_source,rent
person_id,34087867,total_matches,5,page,0,minrent,200,maxrent,600,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,5,num_condos,0,submarket_nb,1097,exact_matches,5,location_parse_source,rent
person_id,97745457,total_matches,31,page,0,minrent,1000,maxrent,2500,bed,1,bath,1,pet,1|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,1,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,1,parking_id,0,fitnesscenter_id,0,num_apartments,27,num_condos,4,submarket_nb,739,exact_matches,31,location_parse_source,rent
person_id,97746475,total_matches,1,page,0,minrent,600,maxrent,800,bed,2,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,specials,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,1,num_condos,0,submarket_nb,1620,exact_matches,1,location_parse_source,other
person_id,97741980,total_matches,25,page,1,minrent,600,maxrent,800,bed,3,bath,2,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,23,num_condos,2,submarket_nb,118,exact_matches,25,location_parse_source,other
person_id,97515207,total_matches,62,page,0,minrent,100,maxrent,2000,bed,2,bath,2,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,61,num_condos,1,submarket_nb,1063,exact_matches,62,location_parse_source,rent
person_id,97745454,total_matches,22,page,0,minrent,100,maxrent,600,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,22,num_condos,0,submarket_nb,6726,exact_matches,22,location_parse_source,rent
person_id,97741980,total_matches,25,page,0,minrent,600,maxrent,800,bed,3,bath,2,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,23,num_condos,2,submarket_nb,118,exact_matches,25,location_parse_source,rent
person_id,97745463,total_matches,106,page,0,minrent,1200,maxrent,99999999,bed,3,bath,1,pet,0|1,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,100,num_condos,6,submarket_nb,1760,exact_matches,106,location_parse_source,rent
person_id,94655489,total_matches,114,page,0,minrent,100,maxrent,2000,bed,3,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,106,num_condos,8,submarket_nb,1649,exact_matches,114,location_parse_source,rent
person_id,96357763,total_matches,326,page,4,minrent,600,maxrent,1200,bed,0,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,312,num_condos,14,submarket_nb,715,exact_matches,326,location_parse_source,other
person_id,89089040,total_matches,896,page,4,minrent,100,maxrent,99999999,bed,0,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,857,num_condos,39,submarket_nb,1689,exact_matches,896,location_parse_source,other
person_id,22607114,total_matches,354,page,0,minrent,100,maxrent,800,bed,1,bath,1,pet,1|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,341,num_condos,13,submarket_nb,240,exact_matches,354,location_parse_source,rent
person_id,97745420,total_matches,105,page,0,minrent,100,maxrent,1200,bed,2,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,105,num_condos,1,submarket_nb,1644,exact_matches,105,location_parse_source,other
person_id,97550647,total_matches,23,page,1,minrent,600,maxrent,800,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,23,num_condos,0,submarket_nb,878,exact_matches,23,location_parse_source,other
person_id,97741980,total_matches,370,page,0,minrent,600,maxrent,800,bed,2,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,364,num_condos,6,submarket_nb,118,exact_matches,370,location_parse_source,other
person_id,68165950,total_matches,186,page,0,minrent,100,maxrent,1000,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,173,num_condos,13,submarket_nb,338,exact_matches,186,location_parse_source,rent
person_id,33716853,total_matches,32,page,2,minrent,400,maxrent,400,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,32,num_condos,0,submarket_nb,241,exact_matches,32,location_parse_source,other
person_id,97745447,total_matches,30,page,0,minrent,100,maxrent,99999999,bed,2,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,24,num_condos,6,submarket_nb,21277,exact_matches,30,location_parse_source,other
person_id,73764057,total_matches,66,page,0,minrent,100,maxrent,1200,bed,2,bath,2,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,64,num_condos,2,submarket_nb,315,exact_matches,66,location_parse_source,rent
person_id,881976,total_matches,243,page,0,minrent,200,maxrent,800,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,238,num_condos,5,submarket_nb,180,exact_matches,243,location_parse_source,other
person_id,94670509,total_matches,201,page,15,minrent,100,maxrent,1200,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,1,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,189,num_condos,12,submarket_nb,418,exact_matches,201,location_parse_source,other
person_id,96290101,total_matches,21,page,0,minrent,100,maxrent,800,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,20,num_condos,1,submarket_nb,2696,exact_matches,21,location_parse_source,other
person_id,97741970,total_matches,176,page,0,minrent,400,maxrent,800,bed,2,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,175,num_condos,1,submarket_nb,252,exact_matches,176,location_parse_source,other
person_id,97743126,total_matches,149,page,0,minrent,100,maxrent,1200,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,145,num_condos,4,submarket_nb,733,exact_matches,149,location_parse_source,rent
person_id,78749220,total_matches,197,page,0,minrent,100,maxrent,800,bed,2,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,192,num_condos,5,submarket_nb,514,exact_matches,197,location_parse_source,rent
person_id,97650101,total_matches,389,page,0,minrent,100,maxrent,99999999,bed,2,bath,1,pet,1|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,364,num_condos,25,submarket_nb,1596,exact_matches,389,location_parse_source,rent
person_id,93669151,total_matches,2200,page,4,minrent,100,maxrent,99999999,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,2166,num_condos,34,submarket_nb,21779,exact_matches,2200,location_parse_source,other
person_id,92390726,total_matches,116,page,1,minrent,100,maxrent,99999999,bed,0,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,107,num_condos,9,submarket_nb,220,exact_matches,116,location_parse_source,other
person_id,75305817,total_matches,549,page,8,minrent,800,maxrent,1200,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,544,num_condos,5,submarket_nb,706,exact_matches,549,location_parse_source,other
person_id,97742010,total_matches,114,page,0,minrent,600,maxrent,1000,bed,3,bath,2,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,104,num_condos,10,submarket_nb,242,exact_matches,114,location_parse_source,rent
person_id,97650101,total_matches,389,page,1,minrent,100,maxrent,99999999,bed,2,bath,1,pet,1|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,364,num_condos,25,submarket_nb,1596,exact_matches,389,location_parse_source,other
person_id,96937798,total_matches,13,page,0,minrent,100,maxrent,800,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,595,num_condos,13,submarket_nb,4573,exact_matches,13,location_parse_source,other
person_id,91566278,total_matches,411,page,3,minrent,100,maxrent,1000,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,409,num_condos,2,submarket_nb,8633,exact_matches,411,location_parse_source,other
person_id,35495306,total_matches,71,page,0,minrent,400,maxrent,2000,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,70,num_condos,1,submarket_nb,25506,exact_matches,71,location_parse_source,rent
person_id,97742010,total_matches,114,page,1,minrent,600,maxrent,1000,bed,3,bath,2,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,104,num_condos,10,submarket_nb,242,exact_matches,114,location_parse_source,other
person_id,97735579,total_matches,8,page,0,minrent,1600,maxrent,99999999,bed,2,bath,2,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,20,num_condos,8,submarket_nb,418,exact_matches,8,location_parse_source,other
person_id,75305817,total_matches,549,page,9,minrent,800,maxrent,1200,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,544,num_condos,5,submarket_nb,706,exact_matches,549,location_parse_source,other
person_id,1072033,total_matches,669,page,0,minrent,800,maxrent,1200,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,665,num_condos,4,submarket_nb,666,exact_matches,669,location_parse_source,rent
person_id,52232117,total_matches,195,page,14,minrent,800,maxrent,1000,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,195,num_condos,0,submarket_nb,5260,exact_matches,195,location_parse_source,other
person_id,20560282,total_matches,17,page,0,minrent,100,maxrent,800,bed,2,bath,1,pet,1|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,190,num_condos,17,submarket_nb,848,exact_matches,17,location_parse_source,other
person_id,97743071,total_matches,69,page,0,minrent,1000,maxrent,1600,bed,3,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,58,num_condos,11,submarket_nb,4581,exact_matches,69,location_parse_source,other
person_id,75351219,total_matches,38,page,1,minrent,100,maxrent,99999999,bed,0,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,697,num_condos,38,submarket_nb,1556,exact_matches,38,location_parse_source,other
person_id,97745305,total_matches,248,page,3,minrent,400,maxrent,600,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,243,num_condos,5,submarket_nb,153,exact_matches,248,location_parse_source,other
person_id,52332423,total_matches,24,page,1,minrent,100,maxrent,800,bed,2,bath,2,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,22,num_condos,2,submarket_nb,222,exact_matches,24,location_parse_source,other
person_id,93669151,total_matches,2034,page,0,minrent,100,maxrent,99999999,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,1998,num_condos,36,submarket_nb,29642,exact_matches,2034,location_parse_source,rent
person_id,97746505,total_matches,1,page,0,minrent,100,maxrent,800,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,1,num_condos,0,submarket_nb,10798,exact_matches,1,location_parse_source,rent
person_id,47390004,total_matches,232,page,0,minrent,700,maxrent,2000,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,222,num_condos,10,submarket_nb,29567,exact_matches,232,location_parse_source,rent
person_id,97745442,total_matches,248,page,0,minrent,100,maxrent,99999999,bed,0,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,228,num_condos,20,submarket_nb,652,exact_matches,248,location_parse_source,other
person_id,95597413,total_matches,15,page,0,minrent,1200,maxrent,1400,bed,3,bath,2,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,14,num_condos,1,submarket_nb,706,exact_matches,15,location_parse_source,other
person_id,27622654,total_matches,774,page,15,minrent,100,maxrent,99999999,bed,0,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,702,num_condos,72,submarket_nb,2828,exact_matches,774,location_parse_source,other
person_id,95885557,total_matches,41,page,3,minrent,600,maxrent,800,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,39,num_condos,2,submarket_nb,7379,exact_matches,41,location_parse_source,other
person_id,94670509,total_matches,201,page,16,minrent,100,maxrent,1200,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,1,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,189,num_condos,12,submarket_nb,418,exact_matches,201,location_parse_source,other
person_id,70041900,total_matches,271,page,0,minrent,100,maxrent,600,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,257,num_condos,14,submarket_nb,848,exact_matches,271,location_parse_source,other
person_id,97741970,total_matches,176,page,1,minrent,400,maxrent,800,bed,2,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,175,num_condos,1,submarket_nb,252,exact_matches,176,location_parse_source,other
person_id,40375427,total_matches,349,page,2,minrent,800,maxrent,1000,bed,2,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,345,num_condos,4,submarket_nb,8618,exact_matches,349,location_parse_source,other
person_id,97741692,total_matches,58,page,0,minrent,600,maxrent,1000,bed,2,bath,2,pet,1|1,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,58,num_condos,0,submarket_nb,653,exact_matches,58,location_parse_source,rent
person_id,97745442,total_matches,248,page,1,minrent,100,maxrent,99999999,bed,0,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,228,num_condos,20,submarket_nb,652,exact_matches,248,location_parse_source,other
person_id,56816096,total_matches,594,page,2,minrent,100,maxrent,99999999,bed,0,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,594,num_condos,23,submarket_nb,643,exact_matches,594,location_parse_source,other
person_id,38393196,total_matches,460,page,0,minrent,200,maxrent,600,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,458,num_condos,2,submarket_nb,124,exact_matches,460,location_parse_source,rent
person_id,97743121,total_matches,1,page,0,minrent,600,maxrent,800,bed,3,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,1,num_condos,0,submarket_nb,870,exact_matches,1,location_parse_source,rent
person_id,97745465,total_matches,399,page,0,minrent,100,maxrent,99999999,bed,0,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,371,num_condos,28,submarket_nb,21272,exact_matches,399,location_parse_source,other
person_id,91881134,total_matches,136,page,4,minrent,600,maxrent,800,bed,2,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,129,num_condos,7,submarket_nb,934,exact_matches,136,location_parse_source,other
person_id,40784544,total_matches,115,page,2,minrent,100,maxrent,1400,bed,2,bath,1,pet,1|1,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,113,num_condos,2,submarket_nb,32240,exact_matches,115,location_parse_source,other
person_id,93719342,total_matches,53,page,0,minrent,100,maxrent,800,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,53,num_condos,0,submarket_nb,688,exact_matches,53,location_parse_source,rent
person_id,1828177,total_matches,36,page,1,minrent,100,maxrent,1200,bed,0,bath,1,pet,0|1,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,36,num_condos,0,submarket_nb,1065,exact_matches,36,location_parse_source,other
person_id,95649183,total_matches,114,page,0,minrent,100,maxrent,1000,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,112,num_condos,2,submarket_nb,640,exact_matches,114,location_parse_source,rent
person_id,96357763,total_matches,326,page,4,minrent,600,maxrent,1200,bed,0,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,312,num_condos,14,submarket_nb,715,exact_matches,326,location_parse_source,other
person_id,97738918,total_matches,114,page,0,minrent,100,maxrent,800,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,112,num_condos,2,submarket_nb,653,exact_matches,114,location_parse_source,rent
person_id,97746507,total_matches,110,page,1,minrent,1400,maxrent,2000,bed,3,bath,0,pet,1|1,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,103,num_condos,7,submarket_nb,666,exact_matches,110,location_parse_source,other
person_id,41447496,total_matches,164,page,9,minrent,100,maxrent,800,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,162,num_condos,2,submarket_nb,6741,exact_matches,164,location_parse_source,other
person_id,52232117,total_matches,195,page,15,minrent,800,maxrent,1000,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,195,num_condos,0,submarket_nb,5260,exact_matches,195,location_parse_source,other
person_id,97745407,total_matches,18,page,0,minrent,100,maxrent,1400,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,18,num_condos,0,submarket_nb,10643,exact_matches,18,location_parse_source,rent
person_id,96332569,total_matches,76,page,2,minrent,800,maxrent,1200,bed,3,bath,2,pet,0|1,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,1,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,1,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,75,num_condos,1,submarket_nb,1009,exact_matches,76,location_parse_source,other
person_id,27622654,total_matches,774,page,18,minrent,100,maxrent,99999999,bed,0,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,702,num_condos,72,submarket_nb,2828,exact_matches,774,location_parse_source,other
person_id,1828177,total_matches,36,page,2,minrent,100,maxrent,1200,bed,0,bath,1,pet,0|1,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,36,num_condos,0,submarket_nb,1065,exact_matches,36,location_parse_source,other
person_id,47827700,total_matches,391,page,2,minrent,400,maxrent,800,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,384,num_condos,7,submarket_nb,201,exact_matches,391,location_parse_source,other
person_id,881976,total_matches,243,page,0,minrent,200,maxrent,800,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,238,num_condos,5,submarket_nb,180,exact_matches,243,location_parse_source,other
person_id,97742024,total_matches,13,page,0,minrent,100,maxrent,400,bed,0,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,13,num_condos,2,submarket_nb,978,exact_matches,13,location_parse_source,other
person_id,97742025,total_matches,472,page,0,minrent,100,maxrent,99999999,bed,0,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,472,num_condos,32,submarket_nb,208,exact_matches,472,location_parse_source,other
person_id,97745450,total_matches,17,page,0,minrent,200,maxrent,400,bed,0,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,17,num_condos,0,submarket_nb,153,exact_matches,17,location_parse_source,other
person_id,97742008,total_matches,23,page,0,minrent,400,maxrent,600,bed,0,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,23,num_condos,0,submarket_nb,629,exact_matches,23,location_parse_source,other
person_id,94670509,total_matches,201,page,12,minrent,100,maxrent,1200,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,1,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,189,num_condos,12,submarket_nb,418,exact_matches,201,location_parse_source,other
person_id,36087653,total_matches,322,page,20,minrent,1400,maxrent,2000,bed,2,bath,2,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,305,num_condos,17,submarket_nb,564,exact_matches,322,location_parse_source,other
person_id,97745409,total_matches,206,page,1,minrent,100,maxrent,600,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,202,num_condos,4,submarket_nb,153,exact_matches,206,location_parse_source,other
person_id,68165950,total_matches,186,page,0,minrent,100,maxrent,1000,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,renthigh,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,173,num_condos,13,submarket_nb,338,exact_matches,186,location_parse_source,other
person_id,34462045,total_matches,6,page,0,minrent,100,maxrent,400,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,1,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,6,num_condos,0,submarket_nb,1476,exact_matches,6,location_parse_source,rent
person_id,27622654,total_matches,774,page,20,minrent,100,maxrent,99999999,bed,0,bath,0,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,702,num_condos,72,submarket_nb,2828,exact_matches,774,location_parse_source,other
person_id,97742010,total_matches,114,page,1,minrent,600,maxrent,1000,bed,3,bath,2,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,104,num_condos,10,submarket_nb,242,exact_matches,114,location_parse_source,other
person_id,35495306,total_matches,71,page,1,minrent,400,maxrent,2000,bed,1,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,renthigh,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,70,num_condos,1,submarket_nb,25506,exact_matches,71,location_parse_source,other
person_id,95260926,total_matches,90,page,1,minrent,100,maxrent,1200,bed,0,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,89,num_condos,1,submarket_nb,24739,exact_matches,90,location_parse_source,other
person_id,95713174,total_matches,307,page,1,minrent,100,maxrent,1200,bed,2,bath,1,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,282,num_condos,25,submarket_nb,252,exact_matches,307,location_parse_source,other
person_id,71943175,total_matches,32,page,1,minrent,600,maxrent,800,bed,2,bath,2,pet,0|0,moveindate_updated,DEFUNCT,property_nm,0,lessor,0,parking,DEFUNCT,laundry,DEFUNCT,walkincloset,0,fitness,0,fireplace,DEFUNCT,pool,0,photofirst,DEFUNCT,saveprefs,,sorttype,,washerdryer_id,0,washerdryerhookups_id,0,laundryfacility_id,0,airconditioning_id,0,hardwoodfloor_id,0,parking_id,0,fitnesscenter_id,0,num_apartments,30,num_condos,2,submarket_nb,452,exact_matches,32,location_parse_source,other
